package net.csn.dr2d;

import java.util.ArrayList;

import javax.json.Json;
import javax.json.JsonArray;
import javax.json.JsonArrayBuilder;

/**
 * A Movement is a sequence of action (AnR) composed by 0 or 1 move and 0 or n rotation(s) 
 * 
 */
public class Movement extends ArrayList<AnRType> {

	private static final long serialVersionUID = 1003350810543281851L;
	public Movement(){super();}
	
	/**
	 * 
	 * @param mcndMvt, like in ["0x21B4, Move_Back","0x245A, Move_90Right"]
	 * @return a movement
	 */
	public static Movement fromJsonArray(final JsonArray mcndMvt){
		Movement mvt = new Movement();
		for(int idx=0; idx<mcndMvt.size(); ++idx){
			final String movStr = mcndMvt.getString(idx, null);
			if(movStr==null || movStr.length()<6) continue;
			final AnRType anr = AnRType.fromHexValue(movStr.substring(0, 6));
			mvt.add(anr);
		}
		return mvt;
	}
	
	public static JsonArray toJsonArray(final Movement mcndMvt){
		JsonArrayBuilder jabMov = Json.createArrayBuilder();
		for(AnRType a : mcndMvt){ jabMov.add(a.toHexString()); } // only hexa is needed ...
		return jabMov.build();
	}

}
