package net.csn.dr2d;

public enum SeqType {
	GameInitialisation			("GameInitialisation"), 
	InitDeclareBoard			("InitDeclareBoard"), 
	InitPlayerFeatures			("InitPlayerFeatures"), 
	InitPlayerLocalization		("InitPlayerLocalization"), 
	InitStatusOfCompetitors		("InitStatusOfCompetitors"), 
	InitLocateArtefacts			("InitLocateArtefacts"), 
	QuestStart					("QuestStart"), 
    RoundRequireCartouche		("RoundRequireCartouche"), 
    RoundRobotMovement			("RoundRobotMovement"), 
    RoundBoardMovement			("RoundBoardMovement"),  		//> deux fois de suite
    RoundComputedMovements		("RoundComputedMovements"),  	//> non implémenté
	RoundBoardAction			("RoundBoardAction"), 
    RoundStatusOfCompetitors	("RoundStatusOfCompetitors"), 
    QuestAchieved				("QuestAchieved"), 
    GameFinalisation			("GameFinalisation")
    ;
	String _type;
	SeqType(final String type){
		_type = type;
	}
	public String getValue(){return _type;}
	public static SeqType fromValue(final String val){
		for(SeqType v : values()){
			if(v.getValue().equalsIgnoreCase(val)) return v;
		}
		return null;
	}
}
