package net.csn.dr2d;

import javax.json.Json;
import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;

public class StgyReply extends StgyBulk {

	StgyReply(final JsonObject jsonData) {
		super(jsonData);
	}

	public static StgyReply newStgyReply(final String jsonStgyReply){
		return (StgyReply)StgyBulk.parseFromJSon(jsonStgyReply);
	}

	@Override
	public JsonObject toJSonObject(){
		JsonObjectBuilder body = Json.createObjectBuilder()
			.add(STGYKEY_SEQ, _SeqType.getValue())
			.add(STGYKEY_TOKEN, String.valueOf(_Token));
		if(_ArgsRef!=null) body.add(STGYKEY_ARGSREF, _ArgsRef);

		JsonObject json = Json.createObjectBuilder()
			.add( STGY_REPLY, body)
			.build();
		return json;
	}

	public static StgyReply acknowledge(final StgyCall stgyCall){
		StgyReply stgyReply = null;
		if(stgyCall!=null){
			JsonObjectBuilder body = Json.createObjectBuilder()
				.add(STGYKEY_SEQ, stgyCall.getSequence().getValue())
				.add(STGYKEY_TOKEN, String.valueOf(stgyCall.getToken()));
			if(stgyCall.getJSonArgsRef()!=null) body.add(STGYKEY_ARGSREF, stgyCall.getJSonArgsRef());

			stgyReply = new StgyReply( body.build() );
		}
		return stgyReply;
	}
	
}
