package net.csn.dr2d.wscp;

import javax.json.Json;
import javax.json.JsonArray;
import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;
import net.csn.dr2d.Board;
import net.csn.dr2d.Tile;
import net.csn.dr2d.TileType;

public class CnslPlayerArgs_InitDeclareBoard {

	final public Board board;
	
	/**
	 * 
	 * @param argsIn	{"board":{"boardIdx":0,"boardWidth":8,"boardHeight":8,"boardActiveTiles":[{"tileType":"0x0414, pous_poupe","tileLocX":2, ...
	 * @param argsRef	null
	 */
	public CnslPlayerArgs_InitDeclareBoard(final JsonObject argsIn, final JsonObject argsRef){
		final JsonObject joBoard = argsIn.getJsonObject("board");
		board = new Board();
		board.boardIdx = joBoard.getInt("boardIdx", -1);
		board.boardWidth = joBoard.getInt("boardWidth", 0); 
		board.boardHeight = joBoard.getInt("boardHeight", 0); 
		final JsonArray boardActiveTiles = joBoard.getJsonArray("boardActiveTiles");
		for(int i = 0; i < boardActiveTiles.size(); i++){
			final JsonObject tileItem = boardActiveTiles.getJsonObject(i);
			final String hexVal = tileItem.getString("tileType", "0x0000, neutre");
			TileType tt = TileType.fromHexValue(hexVal.substring(0,5));
			Tile tile = new Tile(tt, tileItem.getInt("tileLocX",0),tileItem.getInt("tileLocY",0));
			board.boardActiveTiles.add(tile);
		}
	}
	
	public JsonObject toJsonObject(){
		JsonObjectBuilder job = Json.createObjectBuilder();
		return job.build();
	}
	
}
