package net.csn.dr2d.wscp;

import java.util.Hashtable;

import javax.json.Json;
import javax.json.JsonArray;
import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;

import net.csn.dr2d.Movement;

public class CnslPlayerArgs_RoundRobotMovement {
	
	public final Hashtable<String, Movement> allRobotsMovements;
	
	/**
	 * 
	 * @param argsIn	{"mcnd02":[],"mcnd01":["0x21B4, Move_Back","0x245A, Move_90Right"]}
	 * @param argsRef	null
	 */
	public CnslPlayerArgs_RoundRobotMovement(final JsonObject argsIn, final JsonObject argsRef){
		allRobotsMovements = new Hashtable<String, Movement>(8);
		for(int mcndIdx = 1; mcndIdx<9; ++mcndIdx){
			final String mcndKey = String.format("mcnd%02d", mcndIdx);
			if(!argsIn.containsKey(mcndKey)) break;
			final JsonArray mcndMvt = argsIn.getJsonArray(mcndKey);
			Movement mov = Movement.fromJsonArray(mcndMvt);
			allRobotsMovements.put(mcndKey, mov);
		}
	}
	
	public JsonObject toJsonObject(){
		JsonObjectBuilder job = Json.createObjectBuilder();
		return job.build();
	}
}
